void draw() {

  background(12);
  translate( -width/2, -height/2, -1300);   // Peasycam intially sets lookAt() at (0,0,0) hence we need to transalte the axis
  pushMatrix();
 if ( lineFlag)
      {
      stroke(64,128);
      for ( int i =0 ; i <= blockWidth * (12) ; i+= blockWidth)
          {
           pushMatrix();                                                  //setting up a matrix to keep the current graphi coordinates
           translate(constantMarginOnRows, constantMarginOnColumns);      //translate to the correct position
           line( i,0,0,i, blockHeight * (numColumns-1)  ,0);              //creating a line (x,y,z)
           popMatrix();                                                   // going back to previos projection matrix   
          }           
      for ( int i = 0 ; i < blockHeight* numColumns ; i+= blockHeight)
          {
           pushMatrix();
           translate(constantMarginOnRows, constantMarginOnColumns); 
           line ( 0,i,0,blockWidth* 12 ,i,0);
           popMatrix();
          }
      }
      
      for ( int  i = 0 ; i< numRows ; i++)
      {  
        for ( int  j= 0 ; j< numColumns ; j++)
            {
              if( dataMatrix[i][j]!=0)
                {
                  int zTranslation = (dataMatrix[i][j]*255/ maxCount);
                  //println(zTranslation);
                  noStroke();
                  colorMode(HSB,100);
                  fill (dataMatrix[i][j],dataMatrix[i][j],dataMatrix[i][j], 92 );                    // setting up a color for the box
                  pushMatrix();                                                          // doing the same for all the boxes, sadly that is the only way to do this
                  translate(constantMarginOnRows, constantMarginOnColumns);    
                                   
                  if(i < 12 && y2006){
                  translate( i* blockWidth + blockWidth/2,  
                  j* blockHeight + blockHeight/2, 0*ballelevation+zTranslation*checkout);                                                                                                                                         // note the movement in z position, it is half of the box's z length, this is because the box is drawn at the center                                               
                  sphere(10);   
                  }                                  
                  if(i > 11 && i < 24 && y2007){
                  translate( (i-12)* blockWidth + blockWidth/2,  
                  j* blockHeight + blockHeight/2, 2*(ballelevation+ballelevation1)+zTranslation*checkout);                                                                                                                                         // note the movement in z position, it is half of the box's z length, this is because the box is drawn at the center                                               
                  sphere(10);   
                  }                
                  if(i > 23 && i < 36 && y2008){
                  translate( (i-24)* blockWidth + blockWidth/2,  
                  j* blockHeight + blockHeight/2, 4*(ballelevation+ballelevation1)+zTranslation*checkout);                                                                                                                                         // note the movement in z position, it is half of the box's z length, this is because the box is drawn at the center                                               
                  sphere(10);   
                  }
                  if(i > 35 && i < 48 && y2009){
                  translate( (i-36)* blockWidth + blockWidth/2,  
                  j* blockHeight + blockHeight/2, 6*(ballelevation+ballelevation1)+zTranslation*checkout);                                                                                                                                         // note the movement in z position, it is half of the box's z length, this is because the box is drawn at the center                                               
                  sphere(10);   
                  }
                  if(i > 47 && i < 60 && y2010){
                  translate( (i-48)* blockWidth + blockWidth/2,  
                  j* blockHeight + blockHeight/2, 8*(ballelevation+ballelevation1)+zTranslation*checkout);                                                                                                                                         // note the movement in z position, it is half of the box's z length, this is because the box is drawn at the center                                               
                  sphere(10);   
                  }
                  if(i > 59 && i < 72 && y2011){
                  translate( (i-60)* blockWidth + blockWidth/2,  
                  j* blockHeight + blockHeight/2, 10*(ballelevation+ballelevation1)+zTranslation*checkout);                                                                                                                                         // note the movement in z position, it is half of the box's z length, this is because the box is drawn at the center                                               
                  sphere(10);   
                  }
                  if(i > 71 && i < 84 && y2012){
                  translate( (i-72)* blockWidth + blockWidth/2,  
                  j* blockHeight + blockHeight/2, 12*(ballelevation+ballelevation1)+zTranslation*checkout);                                                                                                                                         // note the movement in z position, it is half of the box's z length, this is because the box is drawn at the center                                               
                  sphere(10);   
                  }
                  if(i > 83 && i < 96 && y2013){
                  translate( (i-84)* blockWidth + blockWidth/2,  
                  j* blockHeight + blockHeight/2, 14*(ballelevation+ballelevation1)+zTranslation*checkout);                                                                                                                                         // note the movement in z position, it is half of the box's z length, this is because the box is drawn at the center                                               
                  sphere(10);   
                  }
                               
                  if (numberFlag)
                      {
                       // box values
                       translate( 0,0, zTranslation*10);     // translating coordiantes to box position                      
                       textFont(myHelvetica12);
                       textAlign(CENTER,CENTER);
                       fill(0);       
                       text( dataMatrix[i][j] , 0,0  );
                      }     
                  popMatrix();
                }
            }
      }

    //supporting text
    // nochanges required here. As this is being drawn at the base plane
   
   if ( textFlag)
     {
     for ( int  i = 0 ; i< numColumns-1 ; i++)   // y varies
        {
          textFont(myHelvetica48);
          textAlign(RIGHT,CENTER);
          fill(64,192);       
          text( countries[i], constantMarginOnRows*0.75 ,constantMarginOnColumns + blockHeight * i  +  blockHeight/2 );    
        }
               
     for ( int  i = 0 ; i < 12 ; i++)   // y varies
        {
          textFont(myHelvetica48);
          textAlign(CENTER,CENTER);
          fill(64,192);    
         
          text(Month[i], constantMarginOnRows + blockWidth*i+ 50 , constantMarginOnColumns/2);        
        }
     /*
     for ( int  i = 2006 ; i< 2014 ; i++)   // y varies
        {
          textFont(myHelvetica48);
          textAlign(CENTER,CENTER);
          fill(64,192);        
          text(i, constantMarginOnRows + blockWidth + 50 , constantMarginOnColumns/2, (i-2006)*2);        
        }
        */   
    textFont(myHelvetica48);
    textAlign(LEFT ,CENTER);
    fill(64);
    text( "3D Graph: Comicbook checkouts by countries: 2006 - 2013 " , constantMarginOnRows , constantMarginOnColumns/2-50 );   
     } 
  popMatrix();
  // makes the gui stay on top of elements
  // drawn before.
 
  gui();
 
  
   
  if(mouseX > 0  && mouseX < 261 && mouseY > 749 && mouseY < 840){
    cam.setMouseControlled(false);
  } else {
  cam.setMouseControlled(true);
  }
   
 /*
   cp5.addSlider("ballelevation1")
     .setPosition(30,750)
     .setSize(200,20)
     .setRange(0,200)
     .setValue(0)
     ;
     
     cp5.addSlider("checkout")
     .setPosition(30,780)
     .setSize(200,20)
     .setRange(0,200)
     .setValue(0)
     ;
  */
  
}
